Subject: Re: [PATCH 1/1] net_sched: drr: warn when qdisc is not work conserving

From: Florian Westphal <[email-masked]>
Date: Thu, 12 Jun 2014 18:38:03 +0200

Patrick McHardy <[email-masked]> wrote:
> On 11. Juni 2014 20:35:18 MESZ, Florian Westphal <[email-masked]> wrote:
> >The DRR scheduler requires that items on the active list are work
> >conserving, i.e. do not hold on to skbs for throttling purposes, etc.
> >Attaching e.g. tbf renders DRR useless because all other classes on the
> >active list are delayed as well.
> >
> >So, warn users that this configuration won't work as expected; we
> >already do this in couple of other qdiscs, see e.g.
> 
> Why don't prevent this during configuration time in the first place?
> It doesn't work, a warning might trigger long after creating the broken
> configuration and will more likely go unnoticed.

That would be nice.

But that would require some annotation of the qdiscs wheter they're
wc or not, right?

With such annotation, qdisc_graft() could refuse such request.

Is that what you have in mind?